#ifdef __ICPDAS_VXCAN_Exp
   #ifdef __cplusplus
     #define __VxCANExp extern "C"  DWORD __declspec(dllexport) __stdcall
   #else
     #define __VxCANExp DWORD __declspec(dllexport) __stdcall
   #endif
#else
   #ifdef __cplusplus
     #ifdef _WINDLL
       #define __VxCANExp DWORD __declspec(dllimport) __stdcall            //for VC6
	 #else
       #define __VxCANExp extern "C" DWORD __declspec(dllimport) __stdcall //for BCB6
     #endif
   #else
     #define __VxCANExp DWORD __declspec(dllimport) __stdcall
   #endif
#endif 


//CAN Module Name
#define NAME_I7540D        1000
#define NAME_I7530         1001
#define NAME_I7565         1002
#define NAME_I7565H1       1003
#define NAME_I7565H2       1004
#define NAME_tM7530        1005
#define NAME_I7540DWF      1006
#define NAME_tM7565        1007
#define NAME_I7565MHS      1008
#define NAME_I7565MFD      1009
#define NAME_ECAN240FD     1010
#define NAME_ECAN200FD     1011
#define NAME_tM7530A       1012
#define NAME_PISOCAN200    2000
#define NAME_PISOCAN400    2001
#define NAME_PISOCAN100U   2002
#define NAME_PISOCAN200U   2003
#define NAME_PISOCAN400U   2004
#define NAME_PISOCAN800U   2005
#define NAME_PEXCAN200i    2006
#define NAME_PEXCAN400i    2007
#define NAME_PCMCAN200     2008
#define NAME_PCMCAN400     2009
#define NAME_PCMCAN100     2010
#define NAME_PISOCAN200UFD 2011
#define NAME_PISOCAN400UFD 2012
#define NAME_PISOCM200U    2101
#define NAME_VIRTUAL       3000

#define NAME_

//CAN Baud Rate
#define BR_10K      10000
#define BR_20K      20000
#define BR_50K      50000
#define BR_100K     100000
#define BR_125K     125000
#define BR_250K     250000
#define BR_500K     500000
#define BR_800K     800000
#define BR_1000K    1000000



//General Error Code
#define  VxCAN_NoError      0
#define  ERR_CANIN_EMPTY    1001 //The CAN software reception buffer is empty. There is no data came from the CAN bus. Check the CAN bus wire connection or the CAN baud rate of whole CAN devices.
#define  ERR_CANIN_FULL     1002 //The CAN software reception buffer is full. Try to slow down the transmission speed of the CAN data or try to call the VxCAN_Receive() more frequently. 
#define  ERR_CANOUT_EMPTY   1003 //The CAN software transmission buffer is empty. There is no un-send CAN data in the CAN buffer.
#define  ERR_CANOUT_FULL    1004 //The CAN software transmission buffer is full. Try to slow down the speed of the transmission or check the limitation of the CAN converters.
#define  ERR_InvalidSetting 1005 //The CAN baud rate is invalid. Please check that you have configured it or have called VxCAN_Open() before. 
#define  ERR_VxCANPortError 1006 //There is no such VxCAN port in the PC. Please check the VxCAN port list or search the VxCAN again.

#define HW_NOTSupported 1000000 //The funntion is not supported by HW.(Ives)
#define SetGroupError  1000001  //Total MSG haven't 0 

#define HW_I7540DWF_IPFomatFail 7541000
//DCh^----------------
#define HW_I7540DWF_IPbeenSet   7541001
#define HW_I7540DWF_IPNoExit    7541002 
//------------------------
#define HW_OK    0
//CAN Status for I-7530 / I-7530-FT / I-7530A / I-7530A-MR / I-7565
#define HW_UARTCAN_WaitConfig                  7530000  //I-7530 series / I-7565 is waiting for baud rate configuration
#define HW_UARTCAN_COMPort_FunctionError       7530001  //The function call of the command string is wrong.
#define HW_UARTCAN_COMPort_PortError           7530002  //The COM port number is error..
#define HW_UARTCAN_COMPort_BaudRateError       7530003  //The COM port baud rate is error.
#define HW_UARTCAN_COMPort_DataError           7530004  //The data bit is error.
#define HW_UARTCAN_COMPort_StopError           7530005  //The stop bit is error. 
#define HW_UARTCAN_COMPort_ParityError         7530006  //The parity bit is error.  
#define HW_UARTCAN_COMPort_CheckSumError       7530007  //The checksum of the command string or the response string is error.  
#define HW_UARTCAN_COMPort_ComPortNotOpen      7530008  //The COM port has not been opened.
#define HW_UARTCAN_COMPort_SendThreadCreateError  7530009  //The COM port created transmission thread error. 
#define HW_UARTCAN_COMPort_SendCmdError        7530010  //The COM port is error when sending command. 
#define HW_UARTCAN_COMPort_ReadComStatusError  7530011  //The COM port status is error. 
#define HW_UARTCAN_COMPort_ResultStrCheckError 7530012  //The result string from the COM port checked error.
#define HW_UARTCAN_COMPort_CmdError            7530013  //The COM port command is error. 
#define HW_UARTCAN_COMPort_TimeOut             7530015  //The COM port has no response. Check the wire connection or the power of the CAN converter.
#define HW_UARTCAN_COMPort_ComPortInUse        7530025  //The COM port is using by other program. Check that any software is using the COM port.
#define HW_UARTCAN_COMPort_OpenComError        7530026  //When opening the COM port, it has errors. 
#define HW_UARTCAN_COMPort_SendSizeError       7530027  //The COM port reception size error. 
#define HW_UARTCAN_ModuleNameError             7530030  //The module is not supported.
#define HW_UARTCAN_SendCMDFail                 7530031  //There are errors when sending command to I-7530 series / I-7565.
#define HW_UARTCAN_ModuleNoResponse            7530032  //The I-7530 series or I-7565 did not reply.Check the wire connection or the power of the CAN converter.
#define HW_UARTCAN_ModuleReplyError            7530033  //The I-7530 series or I-7565 replied the error message.
#define HW_UARTCAN_SetBaudRateError            7530034  //When setting the CAN baud rate of the I-7530 series / I-7565, the module replies error.
#define HW_UARTCAN_ACKError                    7530035  //All nodes on the bus that correctly receives a message are expected to send a dominant level in the so-called Acknowledgement Slot in the message. The transmitter will transmit a recessive level here. If the transmitter can't detect a dominant level in the ACK slot, an Acknowledgement Error is signaled.
#define HW_UARTCAN_FormError                   7530036  //The CAN message have a fixed format. Those parts are the CRC Delimiter, ACK Delimiter, End of Frame, and so on. If a CAN controller detects an invalid value in one of the CAN fixed fields, a "Form Error" is signaled.
#define HW_UARTCAN_CRCError                    7530037  //The CAN chip calculates a 15-bit CRC value. Any node that detects a different CRC in the message than what it has calculated itself will signal a CRC error.
#define HW_UARTCAN_StuffError                  7530038  //When the CAN chip detected more than five consecutive bits of the same level, the stuff error is signaled. Check that the terminal resister or add core to filter the noise signal.
#define HW_UARTCAN_DataOverrunError            7530039  //The CAN chip detected the CAN data overrun error. The Overrun error occurs when another CAN data arrives even before the previous CAN data has not been read from the CAN's receive buffer. That means the previous CAN data would be lost.
#define HW_UARTCAN_ErrorPassiveMode            7530040  //The CAN chip is in the error passive mode. When any one of the Tx or Rx error counters raises above 127, the node will enter "Error Passive" state. The CAN converter still works fine.
#define HW_UARTCAN_CANBusOff                   7530041  //The CAN chip is in the bus off state.This is the fatal error of the CAN bus. Check the CAN bus wire connection, baud rate of all CAN modules or terminal resister.
#define HW_UARTCAN_CANBusHasData               7530050  //There are CAN data before module beed activated

#define HW_UARTCAN_GroupSendIsStart            7530100  //Group Send start,plz close or wait for finishing.(Ives)
#define HW_UARTCAN_CoreThreaDontExit           7530101  //Don't Create Core Thread
#define HW_UARTCAN_GroupThreaDontExit          7530102  //Don't Create Group Thread

#define HW_UARTCAN_SearchBaudRateError         7530200  //VxCAN_SearchCANModuleExAll() BaudRateListCount > 15 or Baud Rate value is illegal.
#define HW_UARTCAN_SearchDataBitError          7530201  //VxCAN_SearchCANModuleExAll() DataBitsListCount > 4  or Data bits value is not 5~8.
#define HW_UARTCAN_SearchStopBitError          7530202  //VxCAN_SearchCANModuleExAll() StopBitsListCount > 2  or Stop bits value is not 1~2.
#define HW_UARTCAN_SearchParityError           7530203  //VxCAN_SearchCANModuleExAll() ParityListCount   > 3  or Parity bits value is not 0,1,2.
#define HW_UARTCAN_SearchChecksumError         7530204  //VxCAN_SearchCANModuleExAll() CheckSumListCount > 2  or Checksum value is not 0 or 1.


//CAN Status for I-7540D
#define HW_7540_WaitConfig       7540000  //I-7540D is waiting for baud rate configuration.
#define HW_7540_OpenSocketFail   7540001  //It is fail when opening PC Socket.
#define HW_7540_ConnectFail      7540002  //It is fail when connecting with the I-7540D.
#define HW_7540_SendCMDFail      7540003  //There are errors when sending command to the I-7540D.
#define HW_7540_ModuleNoResponse 7540004  //There is no response message which came from the I-7540D.
#define HW_7540_ModuleReplyError 7540005  //The module replied error or wrong message.
#define HW_7540_SetBaudRateError 7540006  //When setting the CAN baud rate into the I-7540D, the module replied error.
#define HW_7540_TransmitBufferLocked   7540007 //The CAN transmission buffer is locked. The CPU cannot access the transmit buffer. The message is waiting for transmission or is already in process.
#define HW_7540_TransmissionIncomplete 7540008 //The CAN transmission is incomplete. The transmission complete status bit will remain be signaled (incomplete) until a message is transmitted successfully.
#define HW_7540_CANBusOff        7540009  //The CAN chip is in the bus off state.This is the fatal error of the CAN bus. Check the CAN bus wire connection, baud rate of all CAN modules or terminal resister.

#define HW_7540_GroupSendIsStart   7540100   //Group Send start,plz close or wait for finishing.(Ives)
#define HW_7540_CoreThreaDontExit  7540101   //Don't Create Core Thread
#define HW_7540_GroupThreaDontExit 7540102   //Don't Create Group Thread


//CAN Status for I-7565-H1/H2
#define HW_I7565Hx_WaitConfig        7565000  //I-7565H1 or I-7565-H2 is waiting for baud rate configuration.
#define HW_I7565Hx_ModuleNameError   7565001  //The I-7565Hx module's name is error.
#define HW_I7565Hx_ModuleNotExist    7565002  //The I-7565Hx module doesn't exist in this COM port.
#define HW_I7565Hx_COMPortNotExist   7565003  //The COM port doesn't exist.
#define HW_I7565Hx_COMPortInUse      7565004  //The COM port is in used.
#define HW_I7565Hx_COMPortNotOpen    7565005  //The COM port has not been opened.
#define HW_I7565Hx_CANConfigFail     7565006  //The CAN hardware in the module initialized fail.
#define HW_I7565Hx_CANHARDWAREError	 7565007  //The CAN hardware in the module initialized fail.
#define HW_I7565Hx_CANPortNoError    7565008  //The module doesn't support this CAN port.
#define HW_I7565Hx_CANFIDLengthError 7565009  //The total CAN Filter-ID amount exceed the Max. count.
#define HW_I7565Hx_CANDevDisconnect  7565010  //The connection between PC and I-7565Hx is broken.
#define HW_I7565Hx_CANTimeOut        7565011  //There is no response when sending configuration command to the I-7565Hx.
#define HW_I7565Hx_CANConfigCmdError 7565012  //The Configuration command doesn't support.
#define HW_I7565Hx_CANConfigBusy     7565013  //The Configuration command is busy.
#define HW_I7565Hx_CANRxBufEmpty     7565014  //The CAN reception buffer is empty.
#define HW_I7565Hx_CANTxBufFull      7565015  //The CAN transmission buffer is full.
#define HW_I7565Hx_CANUserDefISRNoError	 7565016  //The user-defined ISR No. is error (0~7).
#define HW_I7565Hx_CANHWSendTimerNoError 7565017  //The timer of the hardware send number is error(0~4).
#define HW_I7565Hx_ACKError          7565030  //All nodes on the bus that correctly receives a message are expected to send a dominant level in the so-called Acknowledgement Slot in the message. The transmitter will transmit a recessive level here. If the transmitter can't detect a dominant level in the ACK slot, an Acknowledgement Error is signaled.
#define HW_I7565Hx_FormError         7565031  //The CAN message have a fixed format. Those parts are the CRC Delimiter, ACK Delimiter, End of Frame, and so on. If a CAN controller detects an invalid value in one of the CAN fixed fields, a "Form Error" is signaled.
#define HW_I7565Hx_CRCError          7565032  //The CAN chip calculates a 15-bit CRC value. Any node that detects a different CRC in the message than what it has calculated itself will signal a CRC error.
#define HW_I7565Hx_StuffError        7565033  //When the CAN chip detected more than five consecutive bits of the same level, the stuff error is signaled. Check that the terminal resister or add core to filter the noise signal.
#define HW_I7565Hx_DataOverrunError  7565034  //The CAN chip detected the CAN data overrun error. The Overrun error occurs when another CAN data arrives even before the previous CAN data has not been read from the CAN's receive buffer. That means the previous CAN data would be lost.
#define HW_I7565Hx_ErrorPassiveMode  7565035  //The CAN chip is in the error passive mode. When any one of the Tx or Rx error counters raises above 127, the node will enter "Error Passive" state. The CAN converter still works fine.
#define HW_I7565Hx_CANBusOff         7565036  //The CAN chip is in the bus off state.This is the fatal error of the CAN bus. Check the CAN bus wire connection, baud rate of all CAN modules or terminal resister.
#define HW_I7565Hx_LoadDLLError      7565040  //Load VCI_CAN.DLL Error

#define HW_7565Hx_GroupSendIsStart    7565100 //Group Send start,plz close or wait for finishing.(Ives)
#define HW_7565Hx_CoreThreadDontExit  7565101 //Don't Create Core Thread
#define HW_7565Hx_GroupThreadDontExit 7565102 //Don't Create Group Thread

//Error for PISO-CAN series board
#define HW_PISOCAN_WaitConfig           9030000  //Wait for CAN Baud rate configuration.
#define HW_PISOCAN_DriverError          9030001  //The windows driver of the CAN board is error.
#define HW_PISOCAN_ActiveBoardError     9030002  //This CAN board can't be activated.
#define HW_PISOCAN_BoardNumberError     9030003  //The CAN board number exceeds the maximum board number (7).
#define HW_PISOCAN_PortNumberError      9030004  //The CAN port number exceeds the maximum port number.
#define HW_PISOCAN_ResetError           9030005  //CAN chip hardware reset error.
#define HW_PISOCAN_SoftResetError       9030006  //CAN chip software reset error.
#define HW_PISOCAN_InitError            9030007  //CAN chip initiation error.
#define HW_PISOCAN_ConfigError          9030008  //CAN chip configure error.
#define HW_PISOCAN_SetACRError          9030009  //Set to Acceptance Code Register error.
#define HW_PISOCAN_SetAMRError          9030010  //Set to Acceptance Mask Register error.
#define HW_PISOCAN_SetBaudRateError     9030011  //Set CAN baud rate error.
#define HW_PISOCAN_EnableRxIrqFailure   9030012  //Enable CAN chip receive interrupt failure.
#define HW_PISOCAN_DisableRxIrqFailure  9030013  //Disable CAN chip receive interrupt failure.
#define HW_PISOCAN_InstallIrqFailure    9030014  //Installing PCI board IRQ failure.
#define HW_PISOCAN_RemoveIrqFailure     9030015  //Removing PCI board IRQ failure.
#define HW_PISOCAN_TransmitBufferLocked 9030016  //The CAN transmission buffer is locked. The CPU cannot access the transmit buffer. The message is waiting for transmission or is already in process.
#define HW_PISOCAN_TransmitIncomplete   9030017  //The CAN transmission is incomplete. The transmission complete status bit will remain be signaled (incomplete) until a message is transmitted successfully.
#define HW_PISOCAN_ReceiveBufferEmpty   9030018  //CAN chip RXFIFO is empty.
#define HW_PISOCAN_DataOverrun          9030019  //The CAN chip detected the CAN data overrun error. The Overrun error occurs when another CAN data arrives even before the previous CAN data has not been read from the CAN's receive buffer. That means the previous CAN data would be lost.
#define HW_PISOCAN_ReceiveError         9030020  //Receive data is not completed.
#define HW_PISOCAN_SoftBufferIsEmpty    9030021  //Software buffer in driver is empty.
#define HW_PISOCAN_SoftBufferIsFull     9030022  //Software buffer in driver is full.
#define HW_PISOCAN_TimeOut              9030023  //Function no response and timeout.
#define HW_PISOCAN_InstallIsrError	    9030024  //Installing user ISR failure.
#define HW_PISOCAN_CANBusOff            9030030  //The CAN chip is in the bus off state.This is the fatal error of the CAN bus. Check the CAN bus wire connection, baud rate of all CAN modules or terminal resister.
#define HW_PISOCAN_CANError             9030031  //CAN bus have some errors.

#define HW_PISOCAN_GroupSendIsStart     9030100  //Group Send start,plz close or wait for finishing.(Ives)
#define HW_PISOCAN_CoreThreadDontExit   9030101  //Don't Create Core Thread
#define HW_PISOCAN_GroupThreadDontExit  9030102  //Don't Create Group Thread

//VxCAN_CANStringToCANMsg Error Code
#define ConvertErr_20ARemoteFrame  35770001 //The CAN string format has some errors when converting the 2.0A remote frame
#define ConvertErr_20ADataFrame    35770002 //The CAN string format has some errors when converting the 2.0A data frame
#define ConvertErr_20BRemoteFrame  35770003 //The CAN string format has some errors when converting the 2.0B remote frame
#define ConvertErr_20BDataFrame    35770004 //The CAN string format has some errors when converting the 2.0B data frame
#define ConvertErr_CANStringErr    35770005 //The CAN string format has some errors
#define CANErr_InvalidCANID        35770006 //The value of CAN identifier is invalid.
#define CANErr_InvalidCANDataLen   35770007 //The value of CAN data length is invalid.


__VxCANExp VxCAN_DLL_Ver(char VerInfo[600]);

//20220321 This will search all COM ports, baud rates, format and checksum. It will cost about 12 minutes.
__VxCANExp VxCAN_SearchCANModule(void);

//20220307 This will search specific COM ports and baud rates with all formate and checksum. It will cost about 3 minutes.
__VxCANExp VxCAN_SearchCANModuleEx(BYTE COMPortListCount, BYTE COMPortList[], BYTE BaudRateListCount, DWORD BaudRateList[]);

//v3.3 
__VxCANExp VxCAN_GetCurrentCOMPorts(BYTE *COMPortListCount, BYTE COMPortList[]);
__VxCANExp VxCAN_SearchCANModuleExAll(BYTE COMPortListCount, BYTE COMPortList[], BYTE BaudRateListCount, DWORD BaudRateList[], BYTE DataBitsListCount, DWORD DataBitsList[], BYTE StopBitsListCount, DWORD StopBitsList[], BYTE ParityListCount, DWORD ParityList[], BYTE CheckSumListCount, DWORD CheckSumList[]);

__VxCANExp VxCAN_IsSearchCANModuleOK(BYTE *Percentage);
__VxCANExp VxCAN_StopSearch(void);
__VxCANExp VxCAN_TotalCANPort(BYTE *TotalVxCANPort,DWORD VxCAN_NameIDList[], DWORD VxCAN_IDList[], DWORD VxCAN_COMPortBaudRate[], BYTE **VxCAN_NameStr, BYTE **VxCAN_VerStr, BYTE VxCAN_LocalPortIDList[]);

__VxCANExp VxCAN_OpenCAN(BYTE VxCANPort,DWORD CANBaudRate);
__VxCANExp VxCAN_CloseCAN(BYTE VxCANPort);
__VxCANExp VxCAN_Send(BYTE VxCANPort,DWORD ID,BYTE Mode,BYTE RTR,BYTE Len,BYTE Data[8]);
__VxCANExp VxCAN_Send_And_Log(BYTE VxCANPort,DWORD ID,BYTE Mode,BYTE RTR,BYTE Len,BYTE Data[8], BYTE TxTLogFilePath[]);
__VxCANExp VxCAN_Receive(BYTE VxCANPort,DWORD *ID,BYTE *Mode,BYTE *RTR,BYTE *Len,BYTE Data[8],double *MsgTimeStamps);
__VxCANExp VxCAN_Receive_And_Log(BYTE VxCANPort,DWORD *ID,BYTE *Mode,BYTE *RTR,BYTE *Len,BYTE Data[8],double *MsgTimeStamps, BYTE TxTLogFilePath[]);
__VxCANExp VxCAN_RxMsgCount(BYTE VxCANPort,WORD *MsgCount);

__VxCANExp VxCAN_ResetCAN(BYTE VxCANPort);
__VxCANExp VxCAN_CANStatus(BYTE VxCANPort,DWORD *ModuleStatus,DWORD *CANChipStatus);
__VxCANExp VxCAN_ClearRxBuffer(BYTE VxCANPort);
__VxCANExp VxCAN_ClearTxBuffer(BYTE VxCANPort);

__VxCANExp VxCAN_EnableSystemLog(BYTE VxCANPort, BYTE IsEnable); 


__VxCANExp VxCAN_SetGroupMsg(BYTE VxCANPort, BYTE GroupID ,BYTE TotMsg, BYTE (*CAN_Msg)[30] , DWORD *Interval , DWORD *Times , DWORD *Terminal_Interval);
__VxCANExp VxCAN_GroupSendStart(BYTE VxCANPort, BYTE GroupID);
__VxCANExp VxCAN_GroupSendStop(BYTE VxCANPort, BYTE GroupID);
__VxCANExp VxCAN_GroupSendIsTerminal(BYTE VxCANPort, BYTE GroupID, BYTE *SCANIndex, BYTE *TotCANCount, DWORD *SCyclicIndex, DWORD *TotCyclicCount);
__VxCANExp VxCAN_GetCANPortInfo(BYTE VxCANPort, DWORD *VxCAN_NameID, BYTE *NameStr, BYTE *VerStr);
__VxCANExp VxCAN_ConfigSend(BYTE VxCANPort, DWORD CMDCount , BYTE CMD[]);
__VxCANExp VxCAN_ConfigIsResp(BYTE VxCANPort, DWORD *RxCount);
__VxCANExp VxCAN_ConfigReceive(BYTE VxCANPort, DWORD *RxCount ,BYTE Resp[], DWORD Timeout);
__VxCANExp VxCAN_IsConfigMode(BYTE VxCANPort, BYTE *Mode);
__VxCANExp VxCAN_GroupReback(BYTE VxCANPort, BYTE GroupID, void (*UserISR)(), bool Flag);


//v3.0 MISC
__VxCANExp VxCAN_dwIPToBYTEArray (DWORD dwIP, BYTE IPArray[4]);
__VxCANExp VxCAN_BYTEArrayTodwIP (BYTE IPArray[4], DWORD *dwIP);
__VxCANExp VxCAN_GetErrorString (DWORD ErrorCode, char ErrorDescriptionStr[500]);


__VxCANExp VxCAN_Del7540DWF(BYTE IPArray[]);
__VxCANExp VxCAN_Add7540DWF(BYTE IPArray[]);